;-ip.asm- v0.2---------------------------------------------------------------
;          x86 - Dos & Win32 - Assembly Language Programming                ;
;                                                                           ;
; Written by: John A Lyons                                                  ;
; Email     : sysop@megablast.8k.com                                        ;
; Page      : http://www.asmsource.8k.com/                                  ;
; Compiler  : Masm32 v6.13 Microsoft Macro Assembler                        ;
; Date      : 18-Jul-2001                                                   ;
; Purpose   : Displays the current IP number of the machine, and various    ;
;             Winsock information.                                          ;
;                                                                           ;
;      v0.1 : Very basic, just to test the winsock and IP number routine,   ;
;             ugly window.                                                  ;
;      v0.2 : Information placed in a very nice dialog box, and updated the ;
;             about box, plus nice icon. (19-Jul-2001)                      ;
;                                                                           ;
;----------------------------------------------------------------------------

.386
.MODEL  FLAT , STDCALL
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include gdi32.inc
includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib gdi32.lib
include wsock32.inc
includelib wsock32.lib

; external procedure
EXTRN wsprintfA:PROC

; procedures declared later
WinMain         proto :DWORD,:DWORD,:DWORD,:DWORD
DlgProc         proto hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
IP2             proto  hWnd:HWND

.data
ClassName       db "DLGCLASS",0
MenuName        db "MyMenu",0
DlgName         db "MainDialog",0
AppName         db "IP Number",0
AbtName         db "AboutDialog",0

num1            db "%%"
num2            db "%lu",0

hInstance       HINSTANCE ?
CommandLine     LPSTR ?
mem1            db "Load %"
buff            db 256 dup(?)
menuhand        DWORD ?
first           BOOL FALSE

;about data
hwnd            HWND ?
hover           BOOL ?

hFinger         dd ?
orgStatic       dd ?
hwndDlg         dd ?
szOpen          db "open",0

.const
;buttons
IDC_EXIT        equ 3002
;menu
IDM_UPDATE        equ 32000
IDM_EXIT        equ 32003
IDM_ABOUT       equ 32002

;dialog
IDD_IPADDRESS       equ 502
IDD_WSVER       equ 504
IDD_DESC       equ 505
IDD_MAXSOCK        equ 507

IDI_ICON1       equ 5

IDC_URL         equ 9
IDI_CUR1        equ 101

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hDlg:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,DLGWINDOWEXTRA
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
        invoke LoadIcon, hInstance, IDI_ICON1
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
        invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc

	invoke CreateDialogParam,hInstance,ADDR DlgName,NULL,NULL,NULL
	mov   hDlg,eax

	INVOKE ShowWindow, hDlg,SW_SHOWNORMAL
	INVOKE UpdateWindow, hDlg


	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                invoke IsDialogMessage, hDlg, ADDR msg
                .if eax==FALSE
                        INVOKE TranslateMessage, ADDR msg
                        INVOKE DispatchMessage, ADDR msg
                .endif
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

        .if uMsg==WM_GETMINMAXINFO ; 24

                cmp first,FALSE
                jne nob1
                invoke GetMenu,hWnd
                mov menuhand,eax

                invoke DefWindowProc,hWnd,uMsg,wParam,lParam

                ret
        .ELSEIF uMsg==WM_ACTIVATE

                invoke IP2,hWnd
                ;invoke SendDlgItemMessage, hWnd, IDD_WSVER, WM_SETTEXT, 0,ADDR mem1

                ret

	.ELSEIF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
                ret

	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.IF lParam==0
                         .IF ax==IDM_EXIT
                                invoke DestroyWindow,hWnd
                                ret

                         .ELSEIF ax==IDM_UPDATE
                                invoke IP2,hWnd


                         .ELSEIF ax==IDM_ABOUT

                                invoke CreateDialogParam,hInstance, addr AbtName,hWnd,OFFSET DlgProc,NULL
                                mov hwndDlg,eax
                         .ENDIF
		.ELSE
                        .IF ax==IDC_EXIT
                                invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0
                                ret
			.ENDIF
		.ENDIF
	.ELSE

		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
nob1:
        xor    eax,eax
	ret
WndProc endp
IP2             proc  hWnd:HWND
                ;uses ebx hWndWORD, ItemWORD

        LOCAL   HostName[256]:BYTE
        LOCAL   wsadata1:WSADATA
                ;WSADATA STRUCT DWORD
                ;  wVersion      WORD      ?
                ;  wHighVersion  WORD      ?
                ;  szDescription BYTE WSADESCRIPTION_LEN + 1 dup (?)
                ;  szSystemStatus  BYTE WSASYS_STATUS_LEN + 1 dup (?)
                ;  iMaxSockets   WORD      ?
                ;  iMaxUdpDg     WORD      ?
                ;  lpVendorInfo  DWORD      ?
                ;WSADATA ENDS



        invoke WSAStartup, 0101h, ADDR wsadata1
        cmp eax,0
        jne wsfail
        lea ebx,wsadata1
        assume ebx: ptr WSADATA
        lea eax,[ebx].szDescription
        invoke SendDlgItemMessage, hWnd, IDD_DESC, WM_SETTEXT, 0,eax
        xor eax,eax
        mov ax,[ebx].iMaxSockets
           push eax
           push offset num2
           push offset buff
           call wsprintfA
        invoke SendDlgItemMessage, hWnd, IDD_MAXSOCK, WM_SETTEXT, 0,ADDR buff
        xor eax,eax
        mov ax,[ebx].wVersion
           push eax
           push offset num2
           push offset buff
           call wsprintfA
        invoke SendDlgItemMessage, hWnd, IDD_WSVER, WM_SETTEXT, 0,ADDR buff


                ; --- Get hostname ---
        invoke  gethostname, ADDR HostName, 256
        cmp eax,0
        jne wsfail

                ; --- Get hostent from hostname ---
        invoke  gethostbyname, ADDR HostName


        mov             ebx, eax
                ; --- ebx is now ptr to hostent struct ---
        assume  ebx: ptr hostent
        mov             eax, [ebx].h_list
        assume  ebx: nothing
        mov             ebx, eax
                ; --- ebx is now a pointer to an array of pointers to IP's 8-) ---

        ;.WHILE  TRUE
                ; --- get next pointer from array in eax ---
        mov             eax, [ebx]
                ; --- break if null terminator ---
        ;.BREAK .IF eax==0
                ; --- get IP from pointer to IP ---
        mov             eax, [eax]
                ; --- convert to string ---
        invoke  inet_ntoa, eax
                ; --- add to list ---
;        invoke TextOut,hdc,0,0,eax,15
        ;invoke  SendDlgItemMessage, hWnd, Item, CB_ADDSTRING, NULL, eax
        invoke SendDlgItemMessage, hWnd, IDD_IPADDRESS, WM_SETTEXT, 0,eax
                ; --- next pointer ---
        add     ebx, 4

        ;.ENDW
wsfail:
        ret
IP2             endp

;----------------------------------------------------ABOUT procedure
HyperLinkWndProc PROC uses ebx, hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL tmpFont  :LOGFONT 
LOCAL rect:RECT
LOCAL pt:POINT


    .IF uMsg==WM_NCHITTEST
        mov eax, 1
            ret


    .ELSEIF uMsg==WM_MOUSEMOVE
        invoke GetParent,hWnd
        push ebx
        mov ebx,eax
        invoke GetActiveWindow
            .if eax == ebx
                invoke GetCursorPos,addr pt
                invoke GetWindowRect,hWnd,addr rect
                invoke PtInRect,addr rect,pt.x,pt.y
       .if eax
                invoke GetCapture
                .if !eax
                    invoke SetCapture,hWnd
                    mov hover,TRUE
                    invoke InvalidateRect,hWnd,FALSE,FALSE
                    invoke SetCursor,hFinger

                .endif
       .else
                invoke GetCapture

                .if eax
                    invoke ReleaseCapture
                    mov hover,FALSE
                    invoke InvalidateRect,hWnd,FALSE,FALSE
                .endif

       .endif
       .endif
       pop ebx
       xor eax,eax
       ret

    .ELSEIF uMsg==WM_LBUTTONDOWN

            invoke GetWindowText,hWnd,offset buff,sizeof buff       ;change this for using a preset url
            invoke ShellExecute, NULL, offset szOpen, offset buff, NULL, NULL, SW_MAXIMIZE ;change this to represent your preset url
            mov hover,FALSE
            invoke InvalidateRect,hWnd,FALSE,FALSE

            xor eax,eax

            ret
    .ENDIF

    invoke CallWindowProc, orgStatic, hWnd, uMsg, wParam, lParam
    ret

HyperLinkWndProc endp
DlgProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
        .if iMsg==WM_INITDIALOG
                invoke GetDlgItem,hWnd,IDC_EXIT
                invoke SetFocus,eax

                invoke GetDlgItem, hWnd, IDC_URL

                invoke SetWindowLong, eax, GWL_WNDPROC, ADDR HyperLinkWndProc
                mov orgStatic,eax

                invoke LoadCursor,hInstance,IDI_CUR1
                mov hFinger,eax


                xor eax,eax
                ret

        .elseif iMsg==WM_CLOSE
		invoke EndDialog,hWnd,NULL
		mov hwndDlg,0
        .elseif iMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
                ;.if dx==BN_CLICKED
			.if eax==IDC_EXIT
				invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
                                invoke EndDialog,hWnd,NULL
                                mov hwndDlg,0
			.endif
                ;.endif
        .else
		mov eax,FALSE
		ret
        .endif
        mov  eax,TRUE
        ret
DlgProc endp




end start




